diff -Naurd cluster-3.0.0.rc2/gfs2/edit/hexedit.c cluster-3.0.0.rc3/gfs2/edit/hexedit.c
--- cluster-3.0.0.rc2/gfs2/edit/hexedit.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/edit/hexedit.c	2009-06-11 11:02:55.000000000 +0200
@@ -2417,30 +2417,30 @@
 /* ------------------------------------------------------------------------ */
 /* print block type                                                         */
 /* ------------------------------------------------------------------------ */
-void print_block_type(uint64_t block, int type, const char *additional)
+static void print_block_type(uint64_t tblock, int type, const char *additional)
 {
 	if (type <= GFS2_METATYPE_QC)
 		printf("%d (Block %lld is type %d: %s%s)\n", type,
-		       (unsigned long long)block, type, block_type_str[type],
+		       (unsigned long long)tblock, type, block_type_str[type],
 		       additional);
 	else
 		printf("%d (Block %lld is type %d: unknown%s)\n", type,
-		       (unsigned long long)block, type, additional);
+		       (unsigned long long)tblock, type, additional);
 }
 
 /* ------------------------------------------------------------------------ */
 /* find_print block type                                                    */
 /* ------------------------------------------------------------------------ */
-void find_print_block_type(void)
+static void find_print_block_type(void)
 {
-	uint64_t block;
+	uint64_t tblock;
 	struct gfs2_buffer_head *bh;
 	int type;
 
-	block = blockstack[blockhist % BLOCK_STACK_SIZE].block;
-	bh = bread(&sbd.buf_list, block);
+	tblock = blockstack[blockhist % BLOCK_STACK_SIZE].block;
+	bh = bread(&sbd.buf_list, tblock);
 	type = get_block_type(bh->b_data);
-	print_block_type(block, type, "");
+	print_block_type(tblock, type, "");
 	brelse(bh, NOT_UPDATED);
 	gfs2_rgrp_free(&sbd.rglist, not_updated);
 	exit(0);
@@ -2449,17 +2449,17 @@
 /* ------------------------------------------------------------------------ */
 /* Find and print the resource group associated with a given block          */
 /* ------------------------------------------------------------------------ */
-void find_print_block_rg(int bitmap)
+static void find_print_block_rg(int bitmap)
 {
-	uint64_t block, rgblock;
+	uint64_t rblock, rgblock;
 	int i;
 	struct rgrp_list *rgd;
 
-	block = blockstack[blockhist % BLOCK_STACK_SIZE].block;
-	if (block == sbd.sb_addr)
+	rblock = blockstack[blockhist % BLOCK_STACK_SIZE].block;
+	if (rblock == sbd.sb_addr)
 		printf("0 (the superblock is not in the bitmap)\n");
 	else {
-		rgd = gfs2_blk2rgrpd(&sbd, block);
+		rgd = gfs2_blk2rgrpd(&sbd, rblock);
 		if (rgd) {
 			rgblock = rgd->ri.ri_addr;
 			if (bitmap) {
@@ -2467,7 +2467,7 @@
 
 				for (i = 0; i < rgd->ri.ri_length; i++) {
 					bits = &(rgd->bits[i]);
-					if (block - rgd->ri.ri_data0 <
+					if (rblock - rgd->ri.ri_data0 <
 					    ((bits->bi_start + bits->bi_len) *
 					     GFS2_NBBY)) {
 						break;
@@ -2492,9 +2492,9 @@
 /* ------------------------------------------------------------------------ */
 /* find/change/print block allocation (what the bitmap says about block)    */
 /* ------------------------------------------------------------------------ */
-void find_change_block_alloc(int *newval)
+static void find_change_block_alloc(int *newval)
 {
-	uint64_t block;
+	uint64_t ablock;
 	int type;
 	struct rgrp_list *rgd;
 
@@ -2509,19 +2509,19 @@
 		gfs2_rgrp_free(&sbd.rglist, not_updated);
 		exit(-1);
 	}
-	block = blockstack[blockhist % BLOCK_STACK_SIZE].block;
-	if (block == sbd.sb_addr)
+	ablock = blockstack[blockhist % BLOCK_STACK_SIZE].block;
+	if (ablock == sbd.sb_addr)
 		printf("3 (the superblock is not in the bitmap)\n");
 	else {
 		if (newval) {
-			if (gfs2_set_bitmap(&sbd, block, *newval))
+			if (gfs2_set_bitmap(&sbd, ablock, *newval))
 				printf("-1 (block invalid or part of an rgrp).\n");
 			else
 				printf("%d\n", *newval);
 		} else {
-			rgd = gfs2_blk2rgrpd(&sbd, block);
+			rgd = gfs2_blk2rgrpd(&sbd, ablock);
 			if (rgd) {
-				type = gfs2_get_bitmap(&sbd, block, rgd);
+				type = gfs2_get_bitmap(&sbd, ablock, rgd);
 				printf("%d (%s)\n", type, allocdesc[type]);
 				gfs2_rgrp_relse(rgd, not_updated);
 			} else {
@@ -2540,20 +2540,20 @@
 /* ------------------------------------------------------------------------ */
 /* process request to print a certain field from a previously pushed block  */
 /* ------------------------------------------------------------------------ */
-void process_field(const char *field, uint64_t *newval, int print_field)
+static void process_field(const char *field, uint64_t *newval, int print_field)
 {
-	uint64_t block;
+	uint64_t fblock;
 	struct gfs2_buffer_head *bh;
 	int type;
 	struct gfs2_rgrp rg;
 
-	block = blockstack[blockhist % BLOCK_STACK_SIZE].block;
+	fblock = blockstack[blockhist % BLOCK_STACK_SIZE].block;
 	bh = bread(&sbd.buf_list, block);
 	type = get_block_type(bh->b_data);
 	switch (type) {
 	case GFS2_METATYPE_SB:
 		if (print_field)
-			print_block_type(block, type,
+			print_block_type(fblock, type,
 					 " which is not implemented");
 		break;
 	case GFS2_METATYPE_RG:
@@ -2570,7 +2570,7 @@
 		break;
 	case GFS2_METATYPE_RB:
 		if (print_field)
-			print_block_type(block, type,
+			print_block_type(fblock, type,
 					 " which is not implemented");
 		break;
 	case GFS2_METATYPE_DI:
@@ -2596,7 +2596,7 @@
 	case GFS2_METATYPE_QC:
 	default:
 		if (print_field)
-			print_block_type(block, type,
+			print_block_type(fblock, type,
 					 " which is not implemented");
 		break;
 	}
@@ -2607,7 +2607,7 @@
 /* ------------------------------------------------------------------------ */
 /* interactive_mode - accept keystrokes from user and display structures    */
 /* ------------------------------------------------------------------------ */
-void interactive_mode(void)
+static void interactive_mode(void)
 {
 	int ch, Quit;
 
@@ -2725,7 +2725,8 @@
 		case '+':
 			if (dmode == EXTENDED_MODE) {
 				if (edit_row[dmode] + 1 < end_row[dmode]) {
-					if (edit_row[dmode] >= last_entry_onscreen[dmode])
+					if (edit_row[dmode] - start_row[dmode]
+					    + 1 > last_entry_onscreen[dmode])
 						start_row[dmode]++;
 					edit_row[dmode]++;
 				}
@@ -2817,7 +2818,6 @@
 		/* --------------------------------------------------------- */
 		case 0x168:
 			if (dmode == EXTENDED_MODE) {
-				int dsplines = termlines - 6;
 				int ents_per_screen = dsplines /
 					lines_per_row[dmode];
 
@@ -2872,11 +2872,11 @@
 /* ------------------------------------------------------------------------ */
 /* gfs_log_header_in - read in a gfs1-style log header                      */
 /* ------------------------------------------------------------------------ */
-void gfs_log_header_in(struct gfs_log_header *head, char *buf)
+void gfs_log_header_in(struct gfs_log_header *head, char *inbuf)
 {
-	struct gfs_log_header *str = (struct gfs_log_header *) buf;
+	struct gfs_log_header *str = (struct gfs_log_header *) inbuf;
 
-	gfs2_meta_header_in(&head->lh_header, buf);
+	gfs2_meta_header_in(&head->lh_header, inbuf);
 
 	head->lh_flags = be32_to_cpu(str->lh_flags);
 	head->lh_pad = be32_to_cpu(str->lh_pad);
@@ -2909,7 +2909,7 @@
 /* print_ld_blocks - print all blocks given in a log descriptor             */
 /* returns: the number of block numbers it printed                          */
 /* ------------------------------------------------------------------------ */
-int print_ld_blocks(const uint64_t *b, const char *end, int start_line)
+static int print_ld_blocks(const uint64_t *b, const char *end, int start_line)
 {
 	int bcount = 0, i = 0;
 	static char str[256];
@@ -2941,7 +2941,7 @@
 /* fsck_readi - same as libgfs2's gfs2_readi, but sets absolute block #     */
 /*              of the first bit of data read.                              */
 /* ------------------------------------------------------------------------ */
-int fsck_readi(struct gfs2_inode *ip, void *buf, uint64_t offset,
+static int fsck_readi(struct gfs2_inode *ip, void *rbuf, uint64_t roffset,
 	       unsigned int size, uint64_t *abs_block)
 {
 	struct gfs2_sbd *sdp = ip->i_sbd;
@@ -2955,18 +2955,18 @@
 	int copied = 0;
 
 	*abs_block = 0;
-	if (offset >= ip->i_di.di_size)
+	if (roffset >= ip->i_di.di_size)
 		return 0;
-	if ((offset + size) > ip->i_di.di_size)
-		size = ip->i_di.di_size - offset;
+	if ((roffset + size) > ip->i_di.di_size)
+		size = ip->i_di.di_size - roffset;
 	if (!size)
 		return 0;
 	if (isdir) {
-		o = offset % sdp->sd_jbsize;
-		lblock = offset / sdp->sd_jbsize;
+		o = roffset % sdp->sd_jbsize;
+		lblock = roffset / sdp->sd_jbsize;
 	} else {
-		lblock = offset >> sdp->sd_sb.sb_bsize_shift;
-		o = offset & (sdp->bsize - 1);
+		lblock = roffset >> sdp->sd_sb.sb_bsize_shift;
+		o = roffset & (sdp->bsize - 1);
 	}
 
 	if (!ip->i_di.di_height) /* inode_is_stuffed */
@@ -2990,10 +2990,10 @@
 		} else
 			bh = NULL;
 		if (bh) {
-			memcpy(buf, bh->b_data + o, amount);
+			memcpy(rbuf, bh->b_data + o, amount);
 			brelse(bh, not_updated);
 		} else {
-			memset(buf, 0, amount);
+			memset(rbuf, 0, amount);
 		}
 		copied += amount;
 		lblock++;
@@ -3002,7 +3002,7 @@
 	return copied;
 }
 
-void check_journal_wrap(uint64_t seq, uint64_t *highest_seq)
+static void check_journal_wrap(uint64_t seq, uint64_t *highest_seq)
 {
 	if (seq < *highest_seq) {
 		print_gfs2("------------------------------------------------"
@@ -3020,7 +3020,7 @@
 /* ------------------------------------------------------------------------ */
 /* dump_journal - dump a journal file's contents.                           */
 /* ------------------------------------------------------------------------ */
-void dump_journal(const char *journal)
+static void dump_journal(const char *journal)
 {
 	struct gfs2_buffer_head *j_bh = NULL;
 	uint64_t jblock, j_size, jb, abs_block;
@@ -3145,7 +3145,7 @@
 /* ------------------------------------------------------------------------ */
 /* usage - print command line usage                                         */
 /* ------------------------------------------------------------------------ */
-void usage(void)
+static void usage(void)
 {
 	fprintf(stderr,"\nFormat is: gfs2_edit [-c 1] [-V] [-x] [-h] [identify] [-p structures|blocks][blocktype][blockalloc [val]][blockbits][blockrg][find sb|rg|rb|di|in|lf|jd|lh|ld|ea|ed|lb|13|qc][field <f>[val]] /dev/device\n\n");
 	fprintf(stderr,"If only the device is specified, it enters into hexedit mode.\n");
@@ -3220,7 +3220,7 @@
 /* ------------------------------------------------------------------------ */
 /* parameterpass1 - pre-processing for command-line parameters              */
 /* ------------------------------------------------------------------------ */
-void parameterpass1(int argc, char *argv[], int i)
+static void parameterpass1(int argc, char *argv[], int i)
 {
 	if (!strcasecmp(argv[i], "-V")) {
 		printf("%s version %s (built %s %s)\n",
@@ -3271,7 +3271,7 @@
 /*        normals parameters, device name, etc.  The second pass is for     */
 /*        figuring out what structures to print out.                        */
 /* ------------------------------------------------------------------------ */
-void process_parameters(int argc, char *argv[], int pass)
+static void process_parameters(int argc, char *argv[], int pass)
 {
 	int i;
 	uint64_t keyword_blk;
diff -Naurd cluster-3.0.0.rc2/gfs2/edit/hexedit.h cluster-3.0.0.rc3/gfs2/edit/hexedit.h
--- cluster-3.0.0.rc2/gfs2/edit/hexedit.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/edit/hexedit.h	2009-06-11 11:02:55.000000000 +0200
@@ -42,7 +42,6 @@
 #define GFS_LOG_DESC_Q          (402)    /* quota */
 #define GFS_LOG_DESC_LAST       (500)    /* final in a logged transaction */
 
-extern char *prog_name;
 extern uint64_t block;
 extern int blockhist;
 extern int edit_mode;
@@ -81,6 +80,7 @@
 extern uint64_t temp_blk;
 extern uint64_t starting_blk;
 extern const char *block_type_str[15];
+extern int dsplines;
 
 struct gfs_jindex {
         uint64_t ji_addr;       /* starting block of the journal */
@@ -159,6 +159,9 @@
 extern void gfs_log_header_in(struct gfs_log_header *head, char *buf);
 extern void gfs_log_header_print(struct gfs_log_header *lh);
 extern void gfs_dinode_in(struct gfs_dinode *di, char *buf);
+extern void savemeta(char *out_fn, int saveoption);
+extern void restoremeta(const char *in_fn, const char *out_device, int printblocksonly);
+extern uint64_t masterblock(const char *fn);
 
 struct gfs2_dirents {
 	uint64_t block;
diff -Naurd cluster-3.0.0.rc2/gfs2/edit/savemeta.c cluster-3.0.0.rc3/gfs2/edit/savemeta.c
--- cluster-3.0.0.rc2/gfs2/edit/savemeta.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/edit/savemeta.c	2009-06-11 11:02:55.000000000 +0200
@@ -40,7 +40,6 @@
 int journals_found = 0;
 
 extern void read_superblock(void);
-uint64_t masterblock(const char *fn);
 
 /*
  * get_gfs_struct_info - get block type and structure length
@@ -51,14 +50,14 @@
  * returns: 0 if successful
  *          -1 if this isn't gfs metadata.
  */
-int get_gfs_struct_info(char *buf, int *block_type, int *struct_len)
+static int get_gfs_struct_info(char *gbuf, int *block_type, int *gstruct_len)
 {
 	struct gfs2_meta_header mh;
 
 	*block_type = 0;
-	*struct_len = sbd.bsize;
+	*gstruct_len = sbd.bsize;
 
-	gfs2_meta_header_in(&mh, buf);
+	gfs2_meta_header_in(&mh, gbuf);
 	if (mh.mh_magic != GFS2_MAGIC)
 		return -1;
 
@@ -66,46 +65,52 @@
 
 	switch (mh.mh_type) {
 	case GFS2_METATYPE_SB:   /* 1 (superblock) */
-		*struct_len = sizeof(struct gfs_sb);
+		*gstruct_len = sizeof(struct gfs_sb);
 		break;
 	case GFS2_METATYPE_RG:   /* 2 (rsrc grp hdr) */
-		*struct_len = sbd.bsize; /*sizeof(struct gfs_rgrp);*/
+		*gstruct_len = sbd.bsize; /*sizeof(struct gfs_rgrp);*/
 		break;
 	case GFS2_METATYPE_RB:   /* 3 (rsrc grp bitblk) */
-		*struct_len = sbd.bsize;
+		*gstruct_len = sbd.bsize;
 		break;
 	case GFS2_METATYPE_DI:   /* 4 (disk inode) */
-		*struct_len = sbd.bsize; /*sizeof(struct gfs_dinode);*/
+		*gstruct_len = sbd.bsize; /*sizeof(struct gfs_dinode);*/
 		break;
 	case GFS2_METATYPE_IN:   /* 5 (indir inode blklst) */
-		*struct_len = sbd.bsize; /*sizeof(struct gfs_indirect);*/
+		*gstruct_len = sbd.bsize; /*sizeof(struct gfs_indirect);*/
 		break;
 	case GFS2_METATYPE_LF:   /* 6 (leaf dinode blklst) */
-		*struct_len = sbd.bsize; /*sizeof(struct gfs_leaf);*/
+		*gstruct_len = sbd.bsize; /*sizeof(struct gfs_leaf);*/
 		break;
 	case GFS2_METATYPE_JD:   /* 7 (journal data) */
 		/* GFS1 keeps indirect pointers in GFS2_METATYPE_JD blocks
 		   so we need to save the whole block.  For GFS2, we don't
 		   want to, or we might capture user data, which is bad.  */
 		if (gfs1)
-			*struct_len = sbd.bsize;
+			*gstruct_len = sbd.bsize;
 		else
-			*struct_len = sizeof(struct gfs2_meta_header);
+			*gstruct_len = sizeof(struct gfs2_meta_header);
 		break;
 	case GFS2_METATYPE_LH:   /* 8 (log header) */
-		*struct_len = sizeof(struct gfs2_log_header);
+		if (gfs1)
+			*gstruct_len = 512; /* gfs copies the log header
+					       twice and compares the copy,
+					       so we need to save all 512
+					       bytes of it. */
+		else
+			*gstruct_len = sizeof(struct gfs2_log_header);
 		break;
 	case GFS2_METATYPE_LD:   /* 9 (log descriptor) */
-		*struct_len = sbd.bsize;
+		*gstruct_len = sbd.bsize;
 		break;
 	case GFS2_METATYPE_EA:   /* 10 (extended attr hdr) */
-		*struct_len = sbd.bsize;
+		*gstruct_len = sbd.bsize;
 		break;
 	case GFS2_METATYPE_ED:   /* 11 (extended attr data) */
-		*struct_len = sbd.bsize;
+		*gstruct_len = sbd.bsize;
 		break;
 	default:
-		*struct_len = sbd.bsize;
+		*gstruct_len = sbd.bsize;
 		break;
 	}
 	return 0;
@@ -117,12 +122,12 @@
 /* checking every block kills performance.  We only report    */
 /* every second because we don't need 100 extra messages in   */
 /* logs made from verbose mode.                               */
-void warm_fuzzy_stuff(uint64_t block, int force, int save)
+static void warm_fuzzy_stuff(uint64_t wfsblock, int force, int save)
 {
         static struct timeval tv;
         static uint32_t seconds = 0;
         
-	last_reported_block = block;
+	last_reported_block = wfsblock;
 	gettimeofday(&tv, NULL);
 	if (!seconds)
 		seconds = tv.tv_sec;
@@ -135,7 +140,7 @@
 			if (save) {
 				percent = (block * 100) / last_fs_block;
 				printf("%" PRIu64 " metadata blocks (%"
-				       PRIu64 "%%) processed, ", block,
+				       PRIu64 "%%) processed, ", wfsblock,
 				       percent);
 			}
 			if (total_out < 1024 * 1024)
@@ -155,7 +160,7 @@
 	}
 }
 
-int block_is_a_journal(void)
+static int block_is_a_journal(void)
 {
 	int j;
 
@@ -165,7 +170,7 @@
 	return FALSE;
 }
 
-int block_is_systemfile(void)
+static int block_is_systemfile(void)
 {
 	return block_is_jindex() || block_is_inum_file() ||
 		block_is_statfs_file() || block_is_quota_file() ||
@@ -173,7 +178,7 @@
 		block_is_per_node() || block_is_in_per_node();
 }
 
-int save_block(int fd, int out_fd, uint64_t blk)
+static int save_block(int fd, int out_fd, uint64_t blk)
 {
 	int blktype, blklen, outsz;
 	uint16_t trailing0;
@@ -253,7 +258,7 @@
 /*
  * save_indirect_blocks - save all indirect blocks for the given buffer
  */
-void save_indirect_blocks(int out_fd, osi_list_t *cur_list,
+static void save_indirect_blocks(int out_fd, osi_list_t *cur_list,
 			  struct gfs2_buffer_head *mybh, int height, int hgt)
 {
 	uint64_t old_block = 0, indir_block;
@@ -298,7 +303,7 @@
  * For file system journals, the "data" is a mixture of metadata and
  * journaled data.  We want all the metadata and none of the user data.
  */
-void save_inode_data(int out_fd)
+static void save_inode_data(int out_fd)
 {
 	uint32_t height;
 	struct gfs2_inode *inode;
@@ -388,7 +393,7 @@
 	inode_put(inode, not_updated);
 }
 
-void get_journal_inode_blocks(void)
+static void get_journal_inode_blocks(void)
 {
 	int journal;
 	struct gfs2_buffer_head *bh;
@@ -438,6 +443,40 @@
 	}
 }
 
+int next_rg_freemeta(struct rgrp_list *rgd, uint64_t *block, int first)
+{
+	struct gfs2_bitmap *bits = NULL;
+	uint32_t length = rgd->ri.ri_length;
+	uint32_t blk = (first)? 0: (uint32_t)((*block+1)-rgd->ri.ri_data0);
+	int i;
+
+	if(!first && (*block < rgd->ri.ri_data0)) {
+		log_err("next_rg_freemeta:  Start block is outside rgrp "
+			"bounds.\n");
+		exit(1);
+	}
+	for(i=0; i < length; i++){
+		bits = &rgd->bits[i];
+		if(blk < bits->bi_len*GFS2_NBBY)
+			break;
+		blk -= bits->bi_len*GFS2_NBBY;
+	}
+	for(; i < length; i++){
+		bits = &rgd->bits[i];
+		blk = gfs2_bitfit((unsigned char *)rgd->bh[i]->b_data +
+				  bits->bi_offset, bits->bi_len, blk,
+				  GFS2_BLKST_UNLINKED);
+		if(blk != BFITNOENT){
+			*block = blk + (bits->bi_start * GFS2_NBBY) + rgd->ri.ri_data0;
+			break;
+		}
+		blk=0;
+	}
+	if(i == length)
+		return -1;
+	return 0;
+}
+
 void savemeta(char *out_fn, int saveoption)
 {
 	int out_fd;
@@ -603,9 +642,9 @@
 			}
 			/* Save off the other metadata: inodes, etc. */
 			if (saveoption != 2) {
-				while (!gfs2_next_rg_meta(rgd, &block, first)) {
-					int blktype;
+				int blktype;
 
+				while (!gfs2_next_rg_meta(rgd, &block, first)) {
 					warm_fuzzy_stuff(block, FALSE, TRUE);
 					blktype = save_block(sbd.device_fd,
 							     out_fd, block);
@@ -613,6 +652,14 @@
 						save_inode_data(out_fd);
 					first = 0;
 				}
+				/* Save off the free/unlinked meta blocks too.
+				   If we don't, we may run into metadata
+				   allocation issues. */
+				while (!next_rg_freemeta(rgd, &block, first)) {
+					blktype = save_block(sbd.device_fd,
+							     out_fd, block);
+					first = 0;
+				}
 			}
 			gfs2_rgrp_relse(rgd, not_updated);
 		}
@@ -636,32 +683,32 @@
 	exit(0);
 }
 
-int restore_data(int fd, int in_fd, int printblocksonly)
+static int restore_data(int fd, int in_fd, int printblocksonly)
 {
 	size_t rs;
 	uint64_t buf64, writes = 0;
 	uint16_t buf16;
 	int first = 1, pos;
-	char buf[256];
+	char rdbuf[256];
 	char gfs_superblock_id[8] = {0x01, 0x16, 0x19, 0x70,
 				     0x00, 0x00, 0x00, 0x01};
 
 	if (!printblocksonly)
 		lseek(fd, 0, SEEK_SET);
 	lseek(in_fd, 0, SEEK_SET);
-	rs = read(in_fd, buf, sizeof(buf));
-	if (rs != sizeof(buf)) {
+	rs = read(in_fd, rdbuf, sizeof(rdbuf));
+	if (rs != sizeof(rdbuf)) {
 		fprintf(stderr, "Error: File is too small.\n");
 		return -1;
 	}
-	for (pos = 0; pos < sizeof(buf) - sizeof(uint64_t) - sizeof(uint16_t);
+	for (pos = 0; pos < sizeof(rdbuf) - sizeof(uint64_t) - sizeof(uint16_t);
 	     pos++) {
-		if (!memcmp(&buf[pos + sizeof(uint64_t) + sizeof(uint16_t)],
+		if (!memcmp(&rdbuf[pos + sizeof(uint64_t) + sizeof(uint16_t)],
 			    gfs_superblock_id, sizeof(gfs_superblock_id))) {
 			break;
 		}
 	}
-	if (pos == sizeof(buf) - sizeof(uint64_t) - sizeof(uint16_t))
+	if (pos == sizeof(rdbuf) - sizeof(uint64_t) - sizeof(uint16_t))
 		pos = 0;
 	if (lseek(in_fd, pos, SEEK_SET) != pos) {
 		fprintf(stderr, "bad seek: %s from %s:%d: "
@@ -782,7 +829,7 @@
 	return 0;
 }
 
-void complain(const char *complaint)
+static void complain(const char *complaint)
 {
 	fprintf(stderr, "%s\n", complaint);
 	die("Format is: \ngfs2_edit restoremeta <file to restore> "
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/eattr.c cluster-3.0.0.rc3/gfs2/fsck/eattr.c
--- cluster-3.0.0.rc2/gfs2/fsck/eattr.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/eattr.c	2009-06-11 11:02:55.000000000 +0200
@@ -1,8 +1,11 @@
 #include <stdint.h>
 #include <string.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "libgfs2.h"
 #include "fsck.h"
+#include "eattr.h"
 
 static int clear_blk_nodup(struct gfs2_sbd *sbp, uint64_t block)
 {
@@ -14,7 +17,7 @@
 	}
 
 	if(q.dup_block) {
-		log_debug("Not clearing block with marked as a duplicate\n");
+		log_debug( _("Not clearing block with marked as a duplicate\n"));
 		return 1;
 	}
 
@@ -74,8 +77,8 @@
 		if(max_ptrs > ea_hdr->ea_num_ptrs) {
 			return 1;
 		} else {
-			log_debug("  Pointers Required: %d\n"
-				  "  Pointers Reported: %d\n",
+			log_debug( _("  Pointers Required: %d\n"
+				  "  Pointers Reported: %d\n"),
 				  max_ptrs,
 				  ea_hdr->ea_num_ptrs);
 		}
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/fs_recovery.c cluster-3.0.0.rc3/gfs2/fsck/fs_recovery.c
--- cluster-3.0.0.rc2/gfs2/fsck/fs_recovery.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/fs_recovery.c	2009-06-11 11:02:55.000000000 +0200
@@ -4,6 +4,8 @@
 #include <string.h>
 #include <time.h>
 #include <unistd.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "fsck.h"
 #include "fs_recovery.h"
@@ -55,7 +57,7 @@
 {
 	osi_list_t *tmp;
 	struct gfs2_revoke_replay *rr;
-	int wrap, a, b, revoke;
+	int wrap, a, b;
 	int found = 0;
 
 	osi_list_foreach(tmp, &sd_revoke_list) {
@@ -72,8 +74,7 @@
 	wrap = (rr->rr_where < sd_replay_tail);
 	a = (sd_replay_tail < where);
 	b = (where < rr->rr_where);
-	revoke = (wrap) ? (a || b) : (a && b);
-	return revoke;
+	return (wrap) ? (a || b) : (a && b);
 }
 
 void gfs2_revoke_clean(struct gfs2_sbd *sdp)
@@ -246,7 +247,7 @@
  * Returns: errno
  */
 
-int foreach_descriptor(struct gfs2_inode *ip, unsigned int start,
+static int foreach_descriptor(struct gfs2_inode *ip, unsigned int start,
 		       unsigned int end, int pass)
 {
 	struct gfs2_buffer_head *bh;
@@ -321,7 +322,7 @@
  * fix_journal_seq_no - Fix log header sequencing problems
  * @ip: the journal incore inode
  */
-int fix_journal_seq_no(struct gfs2_inode *ip)
+static int fix_journal_seq_no(struct gfs2_inode *ip)
 {
 	int error = 0, wrapped = 0;
 	uint32_t jd_blocks = ip->i_di.di_size / ip->i_sbd->sd_sb.sb_bsize;
@@ -380,14 +381,14 @@
  * Returns: errno
  */
 
-int gfs2_recover_journal(struct gfs2_inode *ip, int j)
+static int gfs2_recover_journal(struct gfs2_inode *ip, int j)
 {
 	struct gfs2_sbd *sdp = ip->i_sbd;
 	struct gfs2_log_header head;
 	unsigned int pass;
 	int error;
 
-	log_info("jid=%u: Looking at journal...\n", j);
+	log_info( _("jid=%u: Looking at journal...\n"), j);
 
 	osi_list_init(&sd_revoke_list);
 	error = gfs2_find_jhead(ip, &head);
@@ -412,12 +413,12 @@
 		log_err("jid=%u: The journal was successfully fixed.\n", j);
 	}
 	if (head.lh_flags & GFS2_LOG_HEAD_UNMOUNT) {
-		log_info("jid=%u: Journal is clean.\n", j);
+		log_info( _("jid=%u: Journal is clean.\n"), j);
 		return 0;
 	}
-	if (query(&opts, "\nJournal #%d (\"journal%d\") is dirty.  Okay to replay it? (y/n)",
+	if (query(&opts, _("\nJournal #%d (\"journal%d\") is dirty.  Okay to replay it? (y/n)"),
 		    j+1, j)) {
-		log_info("jid=%u: Replaying journal...\n", j);
+		log_info( _("jid=%u: Replaying journal...\n"), j);
 
 		sd_found_jblocks = sd_replayed_jblocks = 0;
 		sd_found_metablocks = sd_replayed_metablocks = 0;
@@ -429,28 +430,28 @@
 			if (error)
 				goto out;
 		}
-		log_info("jid=%u: Found %u revoke tags\n", j,
+		log_info( _("jid=%u: Found %u revoke tags\n"), j,
 			 sd_found_revokes);
 		gfs2_revoke_clean(sdp);
 		error = clean_journal(ip, &head);
 		if (error)
 			goto out;
-		log_err("jid=%u: Replayed %u of %u journaled data blocks\n",
+		log_err( _("jid=%u: Replayed %u of %u journaled data blocks\n"),
 			j, sd_replayed_jblocks, sd_found_jblocks);
-		log_err("jid=%u: Replayed %u of %u metadata blocks\n",
+		log_err( _("jid=%u: Replayed %u of %u metadata blocks\n"),
 			j, sd_replayed_metablocks, sd_found_metablocks);
 	} else {
-		if (query(&opts, "Do you want to clear the dirty journal instead? (y/n)")) {
+		if (query(&opts, _("Do you want to clear the dirty journal instead? (y/n)"))) {
 			write_journal(sdp, sdp->md.journal[j], j,
 				      sdp->md.journal[j]->i_di.di_size /
 				      sdp->sd_sb.sb_bsize);
 			
 		} else
-			log_err("jid=%u: Dirty journal not replayed or cleared.\n", j);
+			log_err( _("jid=%u: Dirty journal not replayed or cleared.\n"), j);
 	}
 
 out:
-	log_info("jid=%u: %s\n", j, (error) ? "Failed" : "Done");
+	log_info( _("jid=%u: %s\n"), j, (error) ? "Failed" : "Done");
 	return error;
 }
 
@@ -467,7 +468,7 @@
 int replay_journals(struct gfs2_sbd *sdp){
 	int i;
 
-	log_notice("Recovering journals (this may take a while)");
+	log_notice( _("Recovering journals (this may take a while)"));
 
 	/* Get master dinode */
 	sdp->master_dir = gfs2_load_inode(sdp,
@@ -476,7 +477,7 @@
 
 	/* read in the journal index data */
 	if (ji_update(sdp)){
-		log_err("Unable to read in jindex inode.\n");
+		log_err( _("Unable to read in jindex inode.\n"));
 		return -1;
 	}
 
@@ -487,7 +488,7 @@
 		inode_put(sdp->md.journal[i],
 			  (opts.no ? not_updated : updated));
 	}
-	log_notice("\nJournal recovery complete.\n");
+	log_notice( _("\nJournal recovery complete.\n"));
 	inode_put(sdp->master_dir, not_updated);
 	inode_put(sdp->md.jiinode, not_updated);
 	/* Sync the buffers to disk so we get a fresh start. */
